package com.weaver.seconddev.interfaces.workflow.action;

import com.weaver.authority.api.enums.role.AuthRoleQueryRule;
import com.weaver.authority.api.enums.role.AuthRoleResourceType;
import com.weaver.authority.api.enums.role.AuthUserRoleQueryRule;
import com.weaver.authority.api.enums.role.ConversionRule;
import com.weaver.authority.api.req.role.BatchAuthUserRoleDetail;
import com.weaver.authority.api.req.role.BatchAuthUserRoleReq;
import com.weaver.authority.api.resp.role.BatchAuthUserRoleRes;
import com.weaver.authority.api.rest.RemoteAuthorityRoleService;
import com.weaver.common.distribution.genid.IdGenerator;
import com.weaver.common.hrm.util.HrmContextUtil;
import com.weaver.ebuilder.form.client.ebform.data.EbFormDataDubboService;
import com.weaver.framework.rpc.annotation.RpcReference;
import com.weaver.seconddev.interfaces.htjt.util.TransUtil;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.seconddev.interfaces.workflow.util.CommonDevUtil;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.soa.workflow.request.Cell;
import com.weaver.verupgrade.soa.workflow.request.DetailTable;
import com.weaver.verupgrade.soa.workflow.request.Row;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_ChangeInformationExpertsAction")
public class ChangeInformationExpertsAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_750b7a22 = LoggerFactory.getLogger(ChangeInformationExpertsAction.class);

    @Autowired
    private CommonDevUtil commonDevUtil;

    @RpcReference(group = "ebuilderform")
    private EbFormDataDubboService ebFormDataDubboService;
    @RpcReference
    private RemoteAuthorityRoleService ras;
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = request.getRequestid();
//            String workflowid = request.getWorkflowid();
            String tablename = request.getRequestManager().getBillTableName();
            logger_750b7a22.error(String.valueOf("ChangeInformationExpertsAction--start--" + requestid));
            String dataid = commonDevUtil.getidByrequestid(requestid);
            TransUtil tu = new TransUtil();
            RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
//            String tablename = tu.getTableName(workflowid);
            String roleid = "100502830000001498";
            String fbzd = "xxhzj";
            String zjlx1 = "";
            String sqdw = "";
            String sql = "select * from e10_core_business.dbo." + tablename + " where FORM_DATA_ID = " + dataid;
            String poolname = CONN_TYPE.workflow.getType();
            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
            boolean b2 = rs.executeSql(sql, poolname);
            logger_750b7a22.error("b2--" + b2);
            if (rs.next()) {
                zjlx1 = Util.null2String(rs.getString("zjlx1"));
                sqdw = Util.null2String(rs.getString("sqdw"));
            }
            if ("1".equals(zjlx1)) {
                roleid = "100502830000001564";
                fbzd = "xxhzjrdgcl";
            }
            String xxhzj = "";
            String xxhzjrdgcl = "";
            String tenantKey = HrmContextUtil.getCurrentTenantKey();
            logger_750b7a22.error("tenantKey = " + tenantKey);
            String tablename1 = "hrmsubcompanydefined";
            if("t6kj9c07jr".equals(tenantKey)){
                tablename1 = "hrmsubcompanydefined";
            }else if("tttit1yc38".equals(tenantKey)){//光电
                tablename1 = "hrmsubcompanydefined_12";
            }else if("tejiddakia".equals(tenantKey)){//华海
                tablename1 = "hrmsubcompanydefined_11";
            }
            String dfid = "";
            sql = "select xxhzj AS xxhzj, xxhzjrdgcl AS xxhzjrdgcl,b.id as dfid from eteams.dbo.department a,eteams.dbo."+tablename1+" b where a.formdata =b.FORM_DATA_ID  and a.id="+sqdw+" and a.delete_type ='0' and a.tenant_key = '"+tenantKey+"'  and b.delete_type ='0' and b.tenant_key = '"+tenantKey+"'";
            rs.executeSql(sql,CONN_TYPE.hrm.getType());
            if(rs.next()){
                xxhzj = Util.null2String(rs.getString("xxhzj"));
                xxhzjrdgcl = Util.null2String(rs.getString("xxhzjrdgcl"));
                dfid = Util.null2String(rs.getString("dfid"));
            }

            String matrix_value_config_id = "";
            sql = "select id as matrix_value_config_id from eteams.dbo.form_field where form_id in(100546070000000100,110546070000000100,120546070000000100) and is_delete=0 and tenant_key ='"+tenantKey+"' and  data_key='"+fbzd+"'";
            rs.executeSql(sql,CONN_TYPE.hrm.getType());
            if(rs.next()){
                matrix_value_config_id = com.weaver.common.hrm.util.Util.null2String(rs.getString("matrix_value_config_id"));
            }
            String matrix_id = "";
            sql = "select id from eteams.dbo.hrm_matrix hm where id in(100524200000000001,110524200000000001,120524200000000001) and tenant_key ='"+tenantKey+"'";
            rs.executeSql(sql,CONN_TYPE.hrm.getType());
            if(rs.next()){
                matrix_id = com.weaver.common.hrm.util.Util.null2String(rs.getString("id"));
            }
//            sql = "SELECT xxhzj AS xxhzj, xxhzjrdgcl AS xxhzjrdgcl FROM (SELECT t1.*, t2.id AS subcomid FROM eteams.dbo." + tablename1 + " t1 LEFT JOIN eteams.dbo.department t2 ON t1.FORM_DATA_ID = t2.formdata AND t2.delete_type = 0 WHERE t1.DELETE_TYPE = 0) HrmSubcompanyDefined WHERE HrmSubcompanyDefined.delete_type = 0 and subcomid = '" + sqdw +"'";
//            String poolname_cq = CONN_TYPE.workflow.getType();
//            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
//            logger_750b7a22.error("sql--" + sql);
//            boolean b3 = rs.executeSql(sql, poolname_cq);
//            logger_750b7a22.error("b3--" + b3);
//            if (rs.next()) {
//                xxhzj = Util.null2String(rs.getString("xxhzj"));
//                xxhzjrdgcl = Util.null2String(rs.getString("xxhzjrdgcl"));
//            }
            String  admin = tu.getsysadminid(tenantKey);
            BatchAuthUserRoleReq batchAuthUserRoleReq =  new BatchAuthUserRoleReq();
            batchAuthUserRoleReq.setTenantKey(tenantKey);
            batchAuthUserRoleReq.setOperator(Long.valueOf(admin));
            batchAuthUserRoleReq.setConversionRule(ConversionRule.ID);
            batchAuthUserRoleReq.setRoleQueryRule(AuthRoleQueryRule.ID);
            batchAuthUserRoleReq.setUserRoleQueryRule(AuthUserRoleQueryRule.USER);
            List<BatchAuthUserRoleDetail> data = new ArrayList<>();
            try {
                DetailTable[] detailtable = request.getDetailTableInfo().getDetailTable();
                DetailTable dtq = detailtable[0];
                Row[] sq = dtq.getRow();
                for (int j = 0; j < sq.length; ++j) {
                    Row rq = sq[j];
                    Cell[] cq = rq.getCell();
                    String bglx = "";
                    String xm = "";
                    for (int k = 0; k < cq.length; ++k) {
                        Cell cq1 = cq[k];
                        String nameq = cq1.getName().toLowerCase();
                        String valueq = Util.null2String(cq1.getValue());
                        if (nameq.equals("bglx")) {
                            bglx = valueq;
                        }
                        if (nameq.equals("xm")) {
                            xm = valueq;
                        }
                    }
                    logger_750b7a22.error("xm:"+xm+" bglx:"+bglx);
                    String str = "";
                    if (bglx.equals("0")) {
                        str = "新增";
                        sql = "insert into eteams.dbo.hrm_matrix_value_data(id,create_time,update_time,creator,delete_type,tenant_key,matrix_id,matrix_value_config_id,matrix_data_id,relate_id,sort)" +
                                "select max(id)+1,GETDATE(),GETDATE(),"+admin+",0,'"+tenantKey+"',"+matrix_id+","+matrix_value_config_id+","+sqdw+","+xm+",0  from eteams.dbo.hrm_matrix_value_data";
                        rs.executeUpdate(sql,CONN_TYPE.hrm.getType());
                        BatchAuthUserRoleDetail dt = new BatchAuthUserRoleDetail();
                        dt.setUser(xm);
                        dt.setResourceType(AuthRoleResourceType.RESOURCE);
                        dt.setRole(roleid);
                        data.add(dt);
                        batchAuthUserRoleReq.setData(data);
                        if ("0".equals(zjlx1)) {
                            if ("".equals(xxhzj)) {
                                xxhzj = xm;
                            } else if (("," + xxhzj + ",").indexOf("," + xm + ",") < 0) {
                                xxhzj = xxhzj + "," + xm;
                            }
                        } else if ("1".equals(zjlx1)) {
                            if ("".equals(xxhzjrdgcl)) {
                                xxhzjrdgcl = xm;
                            } else if (("," + xxhzjrdgcl + ",").indexOf("," + xm + ",") < 0) {
                                xxhzjrdgcl = xxhzjrdgcl + "," + xm;
                            }
                        }
                    } else if (bglx.equals("1")) {
                        str = "删除";
                        sql =  "update eteams.dbo.auth_user_role set delete_type=1 where  role_id = "+roleid+" and delete_type=0 and user_id in("+xm+")";
                        rs.executeUpdate(sql, CONN_TYPE.hrm.getType());
                        sql = "update hrm_matrix_value_data set delete_type=1 where matrix_id="+matrix_id+" and  matrix_data_id="+sqdw+"   and matrix_value_config_id="+matrix_value_config_id+" and relate_id ='"+xm+"' and tenant_key ='"+tenantKey+"'";
                        rs.executeUpdate(sql,CONN_TYPE.hrm.getType());
                        if ("0".equals(zjlx1)) {
                            if (("," + xxhzj + ",").indexOf("," + xm + ",") >= 0) {
                                xxhzj = ("," + xxhzj + ",").replace(("," + xm + ","), ",");
                                if (",".equals(xxhzj)) {
                                    xxhzj = "";
                                } else {
                                    xxhzj = xxhzj.substring(1, xxhzj.length() - 1);
                                }
                            }
                        } else if ("1".equals(zjlx1)) {
                            if (("," + xxhzjrdgcl + ",").indexOf("," + xm + ",") >= 0) {
                                xxhzjrdgcl = ("," + xxhzjrdgcl + ",").replace(("," + xm + ","), ",");
                                if (",".equals(xxhzjrdgcl)) {
                                    xxhzjrdgcl = "";
                                } else {
                                    xxhzjrdgcl = xxhzjrdgcl.substring(1, xxhzjrdgcl.length() - 1);
                                }
                            }
                        }
                    }
                    logger_750b7a22.error(String.valueOf(requestid + "--ChangeInformationExpertsAction--info--" + str + "信息化专家【" + xm + "】"));
                }
                if("0".equals(zjlx1)){
                    sql = "update eteams.dbo."+tablename1+" set "+fbzd+"='"+xxhzj+"' where id ="+dfid;
                    logger_750b7a22.error(requestid+" sql:"+sql);
                    rs.executeUpdate(sql,CONN_TYPE.hrm.getType());
                }else if("1".equals(zjlx1)){
                    sql = "update eteams.dbo."+tablename1+" set "+fbzd+"='"+xxhzjrdgcl+"' where id ="+dfid;
                    logger_750b7a22.error(requestid+" sql:"+sql);
                    rs.executeUpdate(sql,CONN_TYPE.hrm.getType());
                }

                WeaResult<List<BatchAuthUserRoleRes>> result2 =ras.batchCreateUserRole(batchAuthUserRoleReq);


            } catch (Exception e) {
                logger_750b7a22.error(String.valueOf(e));
                logger_750b7a22.error(String.valueOf(requestid + "--ChangeInformationExpertsAction--error--" + e.toString()));
                return  WeaResult.fail(500, requestid + "--ChangeInformationExpertsAction--error--" + e, getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager()));
            }
            logger_750b7a22.error(String.valueOf("ChangeInformationExpertsAction--end--" + requestid));
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_750b7a22.error("ChangeInformationExpertsAction e: {}", e.getMessage());
            return  WeaResult.fail(500, "ChangeInformationExpertsAction e: {}"+ e, getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
