package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.common.hrm.util.HrmContextUtil;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.seconddev.interfaces.htjt.util.LogUtil;
import com.weaver.seconddev.interfaces.htjt.util.TransUtil;
import com.weaver.seconddev.interfaces.workflow.util.CommonDevUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Service("workflow_action_ZSRM_PUR_INFO_GY151_Action")
public class ZSRM_PUR_INFO_GY151_Action implements EsbServerlessRpcRemoteInterface {
    private final Logger log = LoggerFactory.getLogger(ZSRM_PUR_INFO_GY151_Action.class);

    @Autowired
    private LogUtil logUtil;
    @Autowired
    private CommonDevUtil commonDevUtil;
    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {
        JSONObject requestParams = JSON.parseObject(JSON.toJSONString(params));
        log.error(requestParams.toJSONString());
        String workflowID = requestParams.getString("workflowid");;// 获取工作流程Workflowid的值
        String requestId = requestParams.getString("requestid");;//获取当前流程的requestid
        String requestName = requestParams.getString("requestName");;//获取当前流程的requestid
        String tenantKey = HrmContextUtil.getCurrentTenantKey();
        TransUtil tu = new TransUtil();
        String tableName = tu.getTableName(workflowID,tenantKey);
        log.error("ZSRM_PUR_INFO_GY151_Action requestid:"+requestId);
        logUtil.setJklm("ZSRM_PUR_INFO_GY151_Action");
        logUtil.setLx("1");
        logUtil.setBt(requestName);
        logUtil.setLcid(requestId);
        logUtil.setLclxid(workflowID);
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.workflow.getType();
        rs.setTenantKey(tenantKey);
        String sfxywhjgxxjl = "";//工号
        String mainid = "";
        String sql = "select a.* from e10_core_business.dbo."+tableName+" a,e10_core_business.dbo.wfc_form_data b where a.FORM_DATA_ID =b.dataid and b.requestid ="+requestId;
        rs.executeSql(sql,poolname);
        if(rs.next()){
            sfxywhjgxxjl = Util.null2String(rs.getString("sfxywhjgxxjl"));
            mainid = Util.null2String(rs.getString("FORM_DATA_ID"));
        }
        if("0".equals(sfxywhjgxxjl)){
            sql = "select * from e10_core_business.dbo."+commonDevUtil.getDetailTableName(tableName,"2")+" where FORM_DATA_ID="+mainid+" and is_delete =0 and tenant_key='"+tenantKey+"'";
            rs.executeSql(sql,poolname);
            int cn=rs.getCounts();
            log.error(requestId+"dt2 count:"+cn);
            String[][] str = new String[cn][21];
            int j=0;
            while (rs.next()){
                str[j][0] = requestId + "_" + j;
                str[j][1] = Util.null2String(rs.getString("cgzz"));
                str[j][2] = Util.null2String(rs.getString("cgz"));
                str[j][3] = Util.null2String(rs.getString("wl"));
                str[j][4] = Util.null2String(rs.getString("gyszhh"));
                str[j][5] = Util.null2String(rs.getString("dddw"));
                str[j][6] = Util.null2String(rs.getString("jbdw"));
                str[j][7] = Util.null2String(rs.getString("jbdwfz"));
                str[j][8] = Util.null2String(rs.getString("zsdls"));
                str[j][9] = Util.null2String(rs.getString("bzdls"));
                str[j][10] = Util.null2String(rs.getString("ytjjhsj"));
                str[j][11] = Util.null2String(rs.getString("xsgmsdm"));
                str[j][12] = Util.null2String(rs.getString("jlfl"));
                str[j][13] = Util.null2String(rs.getString("yxqsrq")).replaceAll("-", "");
                str[j][14] = Util.null2String(rs.getString("yxjzrq")).replaceAll("-", "");
                str[j][15] = Util.null2String(rs.getString("jjg"));
                str[j][16] = Util.null2String(rs.getString("jbdw"));
                str[j][17] = Util.null2String(rs.getString("gyswlz"));
                str[j][18] = "";
                str[j][19] = Util.null2String(rs.getString("hb"));
                str[j][20] = requestId;
                j++;
            }
            try {
                log.error(requestId+"param:"+JSON.toJSONString(str));
                logUtil.setTscs(JSON.toJSONString(str));
                ZSRM_PUR_INFO info = new ZSRM_PUR_INFO();
                String[] ret = info.Getexecute(str);
                logUtil.setFhxx(JSON.toJSONString(ret));
                log.error(requestId + "-[" + ret[0] + "," + ret[1] + "]");
                sql = "update " + tableName + " set state=?,message=? where FORM_DATA_ID = " + mainid;
                log.error(requestId+"sql -----"+ sql);
                String[] obj=new String[2];
                obj[0]=ret[0];
                obj[1]=ret[1];
//                rs.executeUpdate(sql,obj);
//                log.error(JSON.toJSONString(rs.getExecuteResult()));
//                if (!"S".equals(ret[0])) {
//                    logUtil.setJkzt("1");
//                    logUtil.insertLog(tenantKey);
//                    return WeaResult.fail(500, "SAP返回错误信息：" + ret[1], new HashMap<>() ,false);
//                }

            } catch (Exception e) {
                logUtil.setFhxx("异常信息："+e.getMessage());
                logUtil.setJkzt("2");
                logUtil.insertLog(tenantKey);
                log.error(requestId+"e:"+e.getMessage());
                log.error("e",e);
                sql = "update " + tableName + " set state='E',message='"+e.toString()+"' where FORM_DATA_ID = " + mainid;
                log.error(requestId+"sql -----"+ sql);
                rs.executeUpdate(sql);
//                return  WeaResult.fail(500, "调用SAP接口校验数据出错："+e.getMessage(), new HashMap<>() ,false);
            }
        }
       return WeaResult.success();
    }


}
